#include "mbed.h"

//------------------------------------
// Hyperterminal configuration
// 9600 bauds, 8-bit data, no parity
//------------------------------------

Serial pc(SERIAL_TX, SERIAL_RX);

DigitalOut myled(LED1);

// TC1668 
DigitalOut LED_CLK(PB_8);
DigitalOut LED_DIO(PB_9);
DigitalOut LED_STB(PB_10);


DigitalOut BUZZER_ON_OFF(PB_3);
DigitalOut BUZZER_MELODY(PA_2);


#define uchar unsigned char 

/*----------------0----1----2----3----4----5----6----7----8----9----A----b----C----d----E----F*/ 
uchar TAB[16] = {0X3f,0X06,0X5B,0X4F,0X66,0X6D,0X7D,0X07,0X7F,0X67,0xDB,0X5E,0XC6,0X1F,0XCE,0XCA};\\
// TM1668 H/W SEG1~8(PIN7~14) / GRID 1~4(PIN 24,23,21,20)/ DIO CLK STB(PIN 1,2,3) 
// SEGMENT 1(A),2(B),3(C),4(D),5(E),6(F),7(G)  DRID N    



void Send_data(uchar dat)   
{   
 uchar i;   
 for(i=0;i<8;i++)   
  {   
   LED_CLK = 0;// CLK_L;   
   if(dat & (1 << i))   LED_DIO = 1;//{DI_H;}   
   else                 LED_DIO = 0;//{DI_L;}   
   asm volatile("NOP"); asm volatile("NOP"); asm volatile("NOP"); asm volatile("NOP"); //asm("nop");   asm volatile("NOP");   
   LED_CLK = 1; //CLK_H;       
  }   
  LED_CLK = 0;// CLK_L;   
}   
   
void DIS_1668(uchar data1,uchar data2,uchar data3,uchar data4) //void DIS_1668(uchar data1,uchar data2,uchar data3,uchar data4)  
{      
    LED_STB = 1; // STB_H;   
    asm volatile("NOP"); asm volatile("NOP"); asm volatile("NOP"); asm volatile("NOP"); // asm("nop"); //  14段   
    LED_STB = 0; // STB_L;   
    Send_data(0X03); //设置显示模式，4位14段    
  
       
    LED_STB = 1; // STB_H;   
    asm volatile("NOP"); asm volatile("NOP"); asm volatile("NOP"); asm volatile("NOP");  // asm("nop");   
    LED_STB = 0; //  // STB_L;   
    Send_data(0X44); //固定地址   
    
    //data1 = 0x00; FND D2(중간)      
    LED_STB = 1; // STB_H;   
    asm volatile("NOP"); asm volatile("NOP"); asm volatile("NOP"); asm volatile("NOP");  // asm("nop");   
    LED_STB = 0; // STB_L;   
    Send_data(0XC2); //?送地址   
    Send_data(data1);//data1 = 0x00; FND D2(중간)   
    //data2 = 0x00; // FND D3(우측)   
    LED_STB = 1; // STB_H;   
    asm volatile("NOP"); asm volatile("NOP"); asm volatile("NOP"); asm volatile("NOP");  // asm("nop");   
    LED_STB = 0; // STB_L;   
    Send_data(0XC4); //?送地址   
    Send_data(data2);   
    //data3 = 0x00; // FND 해당없음    
    LED_STB = 1; // STB_H;   
    asm volatile("NOP"); asm volatile("NOP"); asm volatile("NOP"); asm volatile("NOP");  // asm("nop");   
    LED_STB = 0; // STB_L;   
    Send_data(0XC6); //?送地址   
    Send_data(data3);   
    data4 = 0x00; // FND D1(좌측)
    LED_STB = 1; // STB_H;   
    asm volatile("NOP"); asm volatile("NOP"); asm volatile("NOP"); asm volatile("NOP");  // asm("nop");   
    LED_STB = 0; // STB_L;   
    Send_data(0XC0); //?送地址   
    Send_data(data4);   
       
    LED_STB = 1; // STB_H;   
    asm volatile("NOP"); asm volatile("NOP"); asm volatile("NOP"); asm volatile("NOP");  //asm("nop");   
    LED_STB = 0; // STB_L;   
    Send_data(0X8B); //??示   
}   


void MODE_Display(uchar data1){

    LED_STB = 1; // STB_H;   
    asm volatile("NOP"); asm volatile("NOP"); asm volatile("NOP"); asm volatile("NOP"); // asm("nop"); //  14段   
    LED_STB = 0; // STB_L;   
    Send_data(0X03); //设置显示模式，4位14段    
  
       
    LED_STB = 1; // STB_H;   
    asm volatile("NOP"); asm volatile("NOP"); asm volatile("NOP"); asm volatile("NOP");  // asm("nop");   
    LED_STB = 0; //  // STB_L;   
    Send_data(0X44); //固定地址   
      
    LED_STB = 1; // STB_H;   
    asm volatile("NOP"); asm volatile("NOP"); asm volatile("NOP"); asm volatile("NOP");  // asm("nop");   
    LED_STB = 0; // STB_L;   
    Send_data(0xC0); //FND 1번 
    Send_data(data1);//data1 = 0x00; FND D1(좌)   
 
    LED_STB = 1; // STB_H;   
    asm volatile("NOP"); asm volatile("NOP"); asm volatile("NOP"); asm volatile("NOP");  //asm("nop");   
    LED_STB = 0; // STB_L;   
    Send_data(0X8B); //??示    
}


void HEATER_Display(uchar data1){

    LED_STB = 1; // STB_H;   
    asm volatile("NOP"); asm volatile("NOP"); asm volatile("NOP"); asm volatile("NOP"); // asm("nop"); //  14段   
    LED_STB = 0; // STB_L;   
    Send_data(0X03); //设置显示模式，4位14段    
  
       
    LED_STB = 1; // STB_H;   
    asm volatile("NOP"); asm volatile("NOP"); asm volatile("NOP"); asm volatile("NOP");  // asm("nop");   
    LED_STB = 0; //  // STB_L;   
    Send_data(0X44); //固定地址   
       
    LED_STB = 1; // STB_H;   
    asm volatile("NOP"); asm volatile("NOP"); asm volatile("NOP"); asm volatile("NOP");  // asm("nop");   
    LED_STB = 0; // STB_L;   
    Send_data(0xC2); //FND 2번 
    Send_data(data1);//data1 = 0x00; FND D2(중간)   
 
    LED_STB = 1; // STB_H;   
    asm volatile("NOP"); asm volatile("NOP"); asm volatile("NOP"); asm volatile("NOP");  //asm("nop");   
    LED_STB = 0; // STB_L;   
    Send_data(0X8B); //??示    
}

void INTENSITY_Display(uchar data1){

    LED_STB = 1; // STB_H;   
    asm volatile("NOP"); asm volatile("NOP"); asm volatile("NOP"); asm volatile("NOP"); // asm("nop"); //  14段   
    LED_STB = 0; // STB_L;   
    Send_data(0X03); //设置显示模式，4位14段    
  
       
    LED_STB = 1; // STB_H;   
    asm volatile("NOP"); asm volatile("NOP"); asm volatile("NOP"); asm volatile("NOP");  // asm("nop");   
    LED_STB = 0; //  // STB_L;   
    Send_data(0X44); //固定地址   
       
    LED_STB = 1; // STB_H;   
    asm volatile("NOP"); asm volatile("NOP"); asm volatile("NOP"); asm volatile("NOP");  // asm("nop");   
    LED_STB = 0; // STB_L;   
    Send_data(0xC4); //FND 3번 
    Send_data(data1);//data1 = 0x00; FND D3(우측)   
 
    LED_STB = 1; // STB_H;   
    asm volatile("NOP"); asm volatile("NOP"); asm volatile("NOP"); asm volatile("NOP");  //asm("nop");   
    LED_STB = 0; // STB_L;   
    Send_data(0X8B); //??示    
}


int main()
{
    int i = 1;  char a=4,b=5;
    pc.printf("Hello World !\n");
    
    
    MODE_Display(TAB[0]);HEATER_Display(TAB[0]);INTENSITY_Display(TAB[0]); 
    while(1) {

        
        myled = 1; // LED is ON
        wait(0.5); // 200 ms
        myled = 0; // LED is OFF
        wait(0.5); // 1 sec        


#if 1  // FND 테스트 프로그그램  -> 정상동작 확인        
    // DIS_1668(TAB[14],TAB[15],TAB[1],TAB[0]);     // DIS_1668();      
//        for(a=0, b=1;a<=8;a++, b++){
            
//            wait(0.5);           
//            DIS_1668(TAB[a],TAB[a],TAB[a],TAB[a]);//DIS_1668(TAB[a],TAB[a],TAB[a],TAB[a]);
//            wait(0.5);
//            DIS_1668(TAB[b],TAB[b],TAB[b],TAB[b]);//DIS_1668(TAB[b],TAB[b],TAB[b],TAB[b]);
//        }
        

        for(a=0;a<=9;a++){ wait(0.5); MODE_Display(TAB[a]); } // FND 1 동작
        for(a=0;a<=9;a++){ wait(0.5); HEATER_Display(TAB[a]); }// FND 2 동작
        for(a=0;a<=9;a++){ wait(0.5); INTENSITY_Display(TAB[a]); }// FND 3 동작 
        
        //display();// Display_FND();//send_data();
#endif


#if 1 // BUZZER //



#endif
        pc.printf("This program runs since %d seconds.\n", i++);
        
        wait(0.5);
        MODE_Display(TAB[0]);HEATER_Display(TAB[0]);INTENSITY_Display(TAB[0]);
        
        //myled = !myled;
    }
}




